<?php
/**
 * StoreFillablePropertiesAddress
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. BU. Продавцы
 *
 * Управление продавцами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\BuClient\Dto;

use \ArrayAccess;
use \Ensi\BuClient\ObjectSerializer;

/**
 * StoreFillablePropertiesAddress Class Doc Comment
 *
 * @category Class
 * @description Адрес
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class StoreFillablePropertiesAddress implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'StoreFillableProperties_address';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'address_string' => 'string',
        'country_code' => 'string',
        'post_index' => 'string',
        'region' => 'string',
        'region_guid' => 'string',
        'area' => 'string',
        'area_guid' => 'string',
        'city' => 'string',
        'city_guid' => 'string',
        'street' => 'string',
        'house' => 'string',
        'block' => 'string',
        'flat' => 'string',
        'porch' => 'string',
        'floor' => 'string',
        'intercom' => 'string',
        'comment' => 'string',
        'geo_lat' => 'string',
        'geo_lon' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'address_string' => null,
        'country_code' => null,
        'post_index' => null,
        'region' => null,
        'region_guid' => null,
        'area' => null,
        'area_guid' => null,
        'city' => null,
        'city_guid' => null,
        'street' => null,
        'house' => null,
        'block' => null,
        'flat' => null,
        'porch' => null,
        'floor' => null,
        'intercom' => null,
        'comment' => null,
        'geo_lat' => null,
        'geo_lon' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'address_string' => false,
        'country_code' => false,
        'post_index' => false,
        'region' => false,
        'region_guid' => false,
        'area' => false,
        'area_guid' => false,
        'city' => false,
        'city_guid' => false,
        'street' => false,
        'house' => false,
        'block' => false,
        'flat' => false,
        'porch' => false,
        'floor' => false,
        'intercom' => false,
        'comment' => false,
        'geo_lat' => false,
        'geo_lon' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'address_string' => 'address_string',
        'country_code' => 'country_code',
        'post_index' => 'post_index',
        'region' => 'region',
        'region_guid' => 'region_guid',
        'area' => 'area',
        'area_guid' => 'area_guid',
        'city' => 'city',
        'city_guid' => 'city_guid',
        'street' => 'street',
        'house' => 'house',
        'block' => 'block',
        'flat' => 'flat',
        'porch' => 'porch',
        'floor' => 'floor',
        'intercom' => 'intercom',
        'comment' => 'comment',
        'geo_lat' => 'geo_lat',
        'geo_lon' => 'geo_lon'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'address_string' => 'setAddressString',
        'country_code' => 'setCountryCode',
        'post_index' => 'setPostIndex',
        'region' => 'setRegion',
        'region_guid' => 'setRegionGuid',
        'area' => 'setArea',
        'area_guid' => 'setAreaGuid',
        'city' => 'setCity',
        'city_guid' => 'setCityGuid',
        'street' => 'setStreet',
        'house' => 'setHouse',
        'block' => 'setBlock',
        'flat' => 'setFlat',
        'porch' => 'setPorch',
        'floor' => 'setFloor',
        'intercom' => 'setIntercom',
        'comment' => 'setComment',
        'geo_lat' => 'setGeoLat',
        'geo_lon' => 'setGeoLon'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'address_string' => 'getAddressString',
        'country_code' => 'getCountryCode',
        'post_index' => 'getPostIndex',
        'region' => 'getRegion',
        'region_guid' => 'getRegionGuid',
        'area' => 'getArea',
        'area_guid' => 'getAreaGuid',
        'city' => 'getCity',
        'city_guid' => 'getCityGuid',
        'street' => 'getStreet',
        'house' => 'getHouse',
        'block' => 'getBlock',
        'flat' => 'getFlat',
        'porch' => 'getPorch',
        'floor' => 'getFloor',
        'intercom' => 'getIntercom',
        'comment' => 'getComment',
        'geo_lat' => 'getGeoLat',
        'geo_lon' => 'getGeoLon'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('address_string', $data, null);
        $this->setIfExists('country_code', $data, null);
        $this->setIfExists('post_index', $data, null);
        $this->setIfExists('region', $data, null);
        $this->setIfExists('region_guid', $data, null);
        $this->setIfExists('area', $data, null);
        $this->setIfExists('area_guid', $data, null);
        $this->setIfExists('city', $data, null);
        $this->setIfExists('city_guid', $data, null);
        $this->setIfExists('street', $data, null);
        $this->setIfExists('house', $data, null);
        $this->setIfExists('block', $data, null);
        $this->setIfExists('flat', $data, null);
        $this->setIfExists('porch', $data, null);
        $this->setIfExists('floor', $data, null);
        $this->setIfExists('intercom', $data, null);
        $this->setIfExists('comment', $data, null);
        $this->setIfExists('geo_lat', $data, null);
        $this->setIfExists('geo_lon', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets address_string
     *
     * @return string|null
     */
    public function getAddressString()
    {
        return $this->container['address_string'];
    }

    /**
     * Sets address_string
     *
     * @param string|null $address_string Адрес одной строкой
     *
     * @return $this
     */
    public function setAddressString($address_string)
    {


        /*if (is_null($address_string)) {
            throw new \InvalidArgumentException('non-nullable address_string cannot be null');
        }*/
        $this->container['address_string'] = $address_string;

        return $this;
    }

    /**
     * Gets country_code
     *
     * @return string|null
     */
    public function getCountryCode()
    {
        return $this->container['country_code'];
    }

    /**
     * Sets country_code
     *
     * @param string|null $country_code Код страны
     *
     * @return $this
     */
    public function setCountryCode($country_code)
    {


        /*if (is_null($country_code)) {
            throw new \InvalidArgumentException('non-nullable country_code cannot be null');
        }*/
        $this->container['country_code'] = $country_code;

        return $this;
    }

    /**
     * Gets post_index
     *
     * @return string|null
     */
    public function getPostIndex()
    {
        return $this->container['post_index'];
    }

    /**
     * Sets post_index
     *
     * @param string|null $post_index Почтовый индекс
     *
     * @return $this
     */
    public function setPostIndex($post_index)
    {


        /*if (is_null($post_index)) {
            throw new \InvalidArgumentException('non-nullable post_index cannot be null');
        }*/
        $this->container['post_index'] = $post_index;

        return $this;
    }

    /**
     * Gets region
     *
     * @return string|null
     */
    public function getRegion()
    {
        return $this->container['region'];
    }

    /**
     * Sets region
     *
     * @param string|null $region Регион
     *
     * @return $this
     */
    public function setRegion($region)
    {


        /*if (is_null($region)) {
            throw new \InvalidArgumentException('non-nullable region cannot be null');
        }*/
        $this->container['region'] = $region;

        return $this;
    }

    /**
     * Gets region_guid
     *
     * @return string|null
     */
    public function getRegionGuid()
    {
        return $this->container['region_guid'];
    }

    /**
     * Sets region_guid
     *
     * @param string|null $region_guid ФИАС ID региона
     *
     * @return $this
     */
    public function setRegionGuid($region_guid)
    {


        /*if (is_null($region_guid)) {
            throw new \InvalidArgumentException('non-nullable region_guid cannot be null');
        }*/
        $this->container['region_guid'] = $region_guid;

        return $this;
    }

    /**
     * Gets area
     *
     * @return string|null
     */
    public function getArea()
    {
        return $this->container['area'];
    }

    /**
     * Sets area
     *
     * @param string|null $area Район в регионе
     *
     * @return $this
     */
    public function setArea($area)
    {


        /*if (is_null($area)) {
            throw new \InvalidArgumentException('non-nullable area cannot be null');
        }*/
        $this->container['area'] = $area;

        return $this;
    }

    /**
     * Gets area_guid
     *
     * @return string|null
     */
    public function getAreaGuid()
    {
        return $this->container['area_guid'];
    }

    /**
     * Sets area_guid
     *
     * @param string|null $area_guid ФИАС ID района в регионе
     *
     * @return $this
     */
    public function setAreaGuid($area_guid)
    {


        /*if (is_null($area_guid)) {
            throw new \InvalidArgumentException('non-nullable area_guid cannot be null');
        }*/
        $this->container['area_guid'] = $area_guid;

        return $this;
    }

    /**
     * Gets city
     *
     * @return string|null
     */
    public function getCity()
    {
        return $this->container['city'];
    }

    /**
     * Sets city
     *
     * @param string|null $city Город/населенный пункт
     *
     * @return $this
     */
    public function setCity($city)
    {


        /*if (is_null($city)) {
            throw new \InvalidArgumentException('non-nullable city cannot be null');
        }*/
        $this->container['city'] = $city;

        return $this;
    }

    /**
     * Gets city_guid
     *
     * @return string|null
     */
    public function getCityGuid()
    {
        return $this->container['city_guid'];
    }

    /**
     * Sets city_guid
     *
     * @param string|null $city_guid ФИАС ID города/населенного пункта
     *
     * @return $this
     */
    public function setCityGuid($city_guid)
    {


        /*if (is_null($city_guid)) {
            throw new \InvalidArgumentException('non-nullable city_guid cannot be null');
        }*/
        $this->container['city_guid'] = $city_guid;

        return $this;
    }

    /**
     * Gets street
     *
     * @return string|null
     */
    public function getStreet()
    {
        return $this->container['street'];
    }

    /**
     * Sets street
     *
     * @param string|null $street Улица
     *
     * @return $this
     */
    public function setStreet($street)
    {


        /*if (is_null($street)) {
            throw new \InvalidArgumentException('non-nullable street cannot be null');
        }*/
        $this->container['street'] = $street;

        return $this;
    }

    /**
     * Gets house
     *
     * @return string|null
     */
    public function getHouse()
    {
        return $this->container['house'];
    }

    /**
     * Sets house
     *
     * @param string|null $house Дом
     *
     * @return $this
     */
    public function setHouse($house)
    {


        /*if (is_null($house)) {
            throw new \InvalidArgumentException('non-nullable house cannot be null');
        }*/
        $this->container['house'] = $house;

        return $this;
    }

    /**
     * Gets block
     *
     * @return string|null
     */
    public function getBlock()
    {
        return $this->container['block'];
    }

    /**
     * Sets block
     *
     * @param string|null $block Строение/корпус
     *
     * @return $this
     */
    public function setBlock($block)
    {


        /*if (is_null($block)) {
            throw new \InvalidArgumentException('non-nullable block cannot be null');
        }*/
        $this->container['block'] = $block;

        return $this;
    }

    /**
     * Gets flat
     *
     * @return string|null
     */
    public function getFlat()
    {
        return $this->container['flat'];
    }

    /**
     * Sets flat
     *
     * @param string|null $flat Квартира/офис
     *
     * @return $this
     */
    public function setFlat($flat)
    {


        /*if (is_null($flat)) {
            throw new \InvalidArgumentException('non-nullable flat cannot be null');
        }*/
        $this->container['flat'] = $flat;

        return $this;
    }

    /**
     * Gets porch
     *
     * @return string|null
     */
    public function getPorch()
    {
        return $this->container['porch'];
    }

    /**
     * Sets porch
     *
     * @param string|null $porch Подъезд
     *
     * @return $this
     */
    public function setPorch($porch)
    {


        /*if (is_null($porch)) {
            throw new \InvalidArgumentException('non-nullable porch cannot be null');
        }*/
        $this->container['porch'] = $porch;

        return $this;
    }

    /**
     * Gets floor
     *
     * @return string|null
     */
    public function getFloor()
    {
        return $this->container['floor'];
    }

    /**
     * Sets floor
     *
     * @param string|null $floor Этаж
     *
     * @return $this
     */
    public function setFloor($floor)
    {


        /*if (is_null($floor)) {
            throw new \InvalidArgumentException('non-nullable floor cannot be null');
        }*/
        $this->container['floor'] = $floor;

        return $this;
    }

    /**
     * Gets intercom
     *
     * @return string|null
     */
    public function getIntercom()
    {
        return $this->container['intercom'];
    }

    /**
     * Sets intercom
     *
     * @param string|null $intercom Домофон
     *
     * @return $this
     */
    public function setIntercom($intercom)
    {


        /*if (is_null($intercom)) {
            throw new \InvalidArgumentException('non-nullable intercom cannot be null');
        }*/
        $this->container['intercom'] = $intercom;

        return $this;
    }

    /**
     * Gets comment
     *
     * @return string|null
     */
    public function getComment()
    {
        return $this->container['comment'];
    }

    /**
     * Sets comment
     *
     * @param string|null $comment Комментарий к адресу
     *
     * @return $this
     */
    public function setComment($comment)
    {


        /*if (is_null($comment)) {
            throw new \InvalidArgumentException('non-nullable comment cannot be null');
        }*/
        $this->container['comment'] = $comment;

        return $this;
    }

    /**
     * Gets geo_lat
     *
     * @return string|null
     */
    public function getGeoLat()
    {
        return $this->container['geo_lat'];
    }

    /**
     * Sets geo_lat
     *
     * @param string|null $geo_lat координаты: широта
     *
     * @return $this
     */
    public function setGeoLat($geo_lat)
    {


        /*if (is_null($geo_lat)) {
            throw new \InvalidArgumentException('non-nullable geo_lat cannot be null');
        }*/
        $this->container['geo_lat'] = $geo_lat;

        return $this;
    }

    /**
     * Gets geo_lon
     *
     * @return string|null
     */
    public function getGeoLon()
    {
        return $this->container['geo_lon'];
    }

    /**
     * Sets geo_lon
     *
     * @param string|null $geo_lon координаты: долгота
     *
     * @return $this
     */
    public function setGeoLon($geo_lon)
    {


        /*if (is_null($geo_lon)) {
            throw new \InvalidArgumentException('non-nullable geo_lon cannot be null');
        }*/
        $this->container['geo_lon'] = $geo_lon;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


